<template>
  <PToolbar class="WeekPlanningFilters">
    <template #start>
      <PButton
        icon="mdi mdi-chevron-double-left"
        class="p-button-text"
        :title="
          t('page.weekPlanning.filters.previous', WeekPlanning.config.nbDays)
        "
        @click="() => navigate(-WeekPlanning.config.nbDays)"
      />
      <PButton
        icon="mdi mdi-chevron-left"
        class="p-button-text"
        :title="t('page.weekPlanning.filters.previous', 1)"
        @click="() => navigate(-1)"
      />
      <PButton
        icon="mdi mdi-calendar-today"
        class="p-button-text"
        :title="t('page.weekPlanning.filters.today')"
        @click="() => today()"
      />
      <PCalendar
        id="dueDate"
        :model-value="WeekPlanning.referenceDate.value"
        show-icon
        show-week
        select-other-months
        @update:model-value="debouncedParseDate"
      />
      <PButton
        icon="mdi mdi-chevron-right"
        class="p-button-text"
        :title="t('page.weekPlanning.filters.next', 1)"
        @click="() => navigate(1)"
      />
      <PButton
        icon="mdi mdi-chevron-double-right"
        class="p-button-text"
        :title="t('page.weekPlanning.filters.next', WeekPlanning.config.nbDays)"
        @click="() => navigate(WeekPlanning.config.nbDays)"
      />
    </template>

    <template #end>
      <Settings />
      <Config />
      <PSelectButton
        v-model="WeekPlanning.config.row"
        :options="options"
        option-label="name"
        option-value="value"
        class="WeekPlanningFilters__Row p-button-outlined"
      >
        <template #option="slotProps">
          <i
            :class="`WeekPlanningFilters__RowOption ${slotProps.option.icon}`"
            :title="t(slotProps.option.name)"
          />
        </template>
      </PSelectButton>
    </template>
  </PToolbar>
</template>

<script lang="ts" setup>
import Config from './settings/Config.vue'
import { WeekPlanning } from '@/states'
import { useI18n } from 'vue-i18n'
import moment from 'moment-timezone'
import { usePrimeVue } from 'primevue/config'
import { debounce } from 'lodash'
import { BY_BUSINESS_CASE, BY_WORK_FORCE } from '@/api'
import Settings from '@/pages/weekPlanning/settings/Settings.vue'

const { t } = useI18n()
const options = [
  {
    name: 'page.weekPlanning.filters.byResource',
    value: BY_WORK_FORCE,
    icon: 'mdi mdi-account-multiple-outline',
  },
  {
    name: 'page.weekPlanning.filters.byCase',
    value: BY_BUSINESS_CASE,
    icon: 'mdi mdi-handshake-outline',
  },
]
const prime = usePrimeVue()

/**
 * Parse user input date
 */
const debouncedParseDate = debounce((date: string | null) => {
  const current = moment(date, prime.config.locale?.dateFormat, true)
  if (current.isValid()) WeekPlanning.config.date = current.toDate()
}, 250)

function navigate(quantity: number) {
  WeekPlanning.config.date = moment(WeekPlanning.referenceDate.value)
    .add(quantity, 'day')
    .toDate()
}

function today() {
  WeekPlanning.config.date = null
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.WeekPlanningFilters {
  &__Row {
    :deep(.p-button) {
      padding: 0;
    }
  }

  &__RowOption {
    padding: v.$spacing-4 v.$spacing-2;
  }
}
</style>
